"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.temporaryErrorHttpCodes = exports.HttpError = exports.FetchError = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectSpread3 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _stringify = _interopRequireDefault(require("@babel/runtime/core-js/json/stringify"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));

var _get_root_based_url = _interopRequireDefault(require("./get_root_based_url"));

var _constants = require("./constants");

var FetchError =
/*#__PURE__*/
function (_Error) {
  (0, _inherits2.default)(FetchError, _Error);

  function FetchError() {
    (0, _classCallCheck2.default)(this, FetchError);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(FetchError).apply(this, arguments));
  }

  return FetchError;
}((0, _wrapNativeSuper2.default)(Error));

exports.FetchError = FetchError;

var HttpError =
/*#__PURE__*/
function (_Error2) {
  (0, _inherits2.default)(HttpError, _Error2);

  function HttpError() {
    (0, _classCallCheck2.default)(this, HttpError);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(HttpError).apply(this, arguments));
  }

  return HttpError;
}((0, _wrapNativeSuper2.default)(Error));

exports.HttpError = HttpError;
var temporaryErrorHttpCodes = [408, // Request Timeout
429, // Too Many Requests
502, // Bad Gateway
503, // Service Unavailable
504, // Gateway Timeout
507, // Insufficient Storage
509, // Bandwidth Limit Exceeded
521, // Web Server Is Down
522, // Connection Timed Out
523, // Origin Is Unreachable
524 // A Timeout Occurred
];
exports.temporaryErrorHttpCodes = temporaryErrorHttpCodes;

var validateStatus = function validateStatus(status) {
  // eslint-disable-next-line eqeqeq
  if (temporaryErrorHttpCodes.find(function (code) {
    return code == status;
  })) {
    throw new FetchError(status);
  }
};

var createApi = function createApi(_ref) {
  var origin = _ref.origin,
      rootPath = _ref.rootPath;
  return {
    loadViewModelState: function () {
      var _loadViewModelState = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(_ref2) {
        var viewModelName, aggregateIds, aggregateArgs, response, result, queryAggregateIds;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                viewModelName = _ref2.viewModelName, aggregateIds = _ref2.aggregateIds, aggregateArgs = _ref2.aggregateArgs;
                _context.prev = 1;
                queryAggregateIds = aggregateIds === '*' ? aggregateIds : aggregateIds.join(',');
                _context.next = 5;
                return fetch((0, _get_root_based_url.default)(origin, rootPath, "/api/query/".concat(viewModelName, "/").concat(queryAggregateIds)), {
                  method: 'POST',
                  headers: {
                    'Content-Type': 'application/json'
                  },
                  credentials: 'same-origin',
                  body: (0, _stringify.default)(aggregateArgs)
                });

              case 5:
                response = _context.sent;
                _context.next = 11;
                break;

              case 8:
                _context.prev = 8;
                _context.t0 = _context["catch"](1);
                throw new FetchError(_context.t0.message);

              case 11:
                validateStatus(response.status);

                if (response.ok) {
                  _context.next = 14;
                  break;
                }

                throw new HttpError(response.text());

              case 14:
                _context.prev = 14;
                _context.next = 17;
                return response.json();

              case 17:
                result = _context.sent;
                _context.next = 23;
                break;

              case 20:
                _context.prev = 20;
                _context.t1 = _context["catch"](14);
                throw new HttpError(_context.t1.message);

              case 23:
                return _context.abrupt("return", result);

              case 24:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[1, 8], [14, 20]]);
      }));

      return function loadViewModelState(_x) {
        return _loadViewModelState.apply(this, arguments);
      };
    }(),
    loadReadModelState: function () {
      var _loadReadModelState = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(_ref3) {
        var readModelName, resolverName, resolverArgs, isReactive, queryId, response, result;
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                readModelName = _ref3.readModelName, resolverName = _ref3.resolverName, resolverArgs = _ref3.resolverArgs, isReactive = _ref3.isReactive, queryId = _ref3.queryId;
                _context2.prev = 1;
                _context2.next = 4;
                return fetch((0, _get_root_based_url.default)(origin, rootPath, "/api/query/".concat(readModelName, "/").concat(resolverName)), {
                  method: 'POST',
                  headers: {
                    'Content-Type': 'application/json'
                  },
                  credentials: 'same-origin',
                  body: (0, _stringify.default)((0, _objectSpread3.default)({}, resolverArgs, isReactive ? (0, _defineProperty2.default)({}, _constants.isReactiveArg, isReactive) : {}, (0, _defineProperty2.default)({}, _constants.queryIdArg, queryId)))
                });

              case 4:
                response = _context2.sent;
                _context2.next = 10;
                break;

              case 7:
                _context2.prev = 7;
                _context2.t0 = _context2["catch"](1);
                throw new FetchError(_context2.t0.message);

              case 10:
                validateStatus(response.status);

                if (response.ok) {
                  _context2.next = 13;
                  break;
                }

                throw new HttpError(response.text());

              case 13:
                _context2.prev = 13;
                _context2.next = 16;
                return response.json();

              case 16:
                result = _context2.sent;
                _context2.next = 22;
                break;

              case 19:
                _context2.prev = 19;
                _context2.t1 = _context2["catch"](13);
                throw new HttpError(_context2.t1.message);

              case 22:
                return _context2.abrupt("return", result);

              case 23:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[1, 7], [13, 19]]);
      }));

      return function loadReadModelState(_x2) {
        return _loadReadModelState.apply(this, arguments);
      };
    }(),
    stopReadModelSubscription: function () {
      var _stopReadModelSubscription = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(_ref5) {
        var readModelName, resolverName, queryId, response, _JSON$stringify2;

        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                readModelName = _ref5.readModelName, resolverName = _ref5.resolverName, queryId = _ref5.queryId;
                _context3.prev = 1;
                _context3.next = 4;
                return fetch((0, _get_root_based_url.default)(origin, rootPath, "/api/query/".concat(readModelName, "/").concat(resolverName)), {
                  method: 'POST',
                  credentials: 'same-origin',
                  headers: {
                    'Content-Type': 'application/json'
                  },
                  body: (0, _stringify.default)((_JSON$stringify2 = {}, (0, _defineProperty2.default)(_JSON$stringify2, _constants.stopSubscriptionArg, true), (0, _defineProperty2.default)(_JSON$stringify2, _constants.queryIdArg, queryId), _JSON$stringify2))
                });

              case 4:
                response = _context3.sent;
                _context3.next = 10;
                break;

              case 7:
                _context3.prev = 7;
                _context3.t0 = _context3["catch"](1);
                throw new FetchError(_context3.t0.message);

              case 10:
                validateStatus(response.status);

                if (response.ok) {
                  _context3.next = 13;
                  break;
                }

                throw new HttpError(response.text());

              case 13:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[1, 7]]);
      }));

      return function stopReadModelSubscription(_x3) {
        return _stopReadModelSubscription.apply(this, arguments);
      };
    }(),
    sendCommand: function () {
      var _sendCommand = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee4(_ref6) {
        var commandType, aggregateId, aggregateName, payload, response;
        return _regenerator.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                commandType = _ref6.commandType, aggregateId = _ref6.aggregateId, aggregateName = _ref6.aggregateName, payload = _ref6.payload;
                _context4.prev = 1;
                _context4.next = 4;
                return fetch((0, _get_root_based_url.default)(origin, rootPath, '/api/commands'), {
                  method: 'POST',
                  headers: {
                    'Content-Type': 'application/json'
                  },
                  credentials: 'same-origin',
                  body: (0, _stringify.default)({
                    type: commandType,
                    aggregateId: aggregateId,
                    aggregateName: aggregateName,
                    payload: payload
                  })
                });

              case 4:
                response = _context4.sent;
                _context4.next = 10;
                break;

              case 7:
                _context4.prev = 7;
                _context4.t0 = _context4["catch"](1);
                throw new FetchError(_context4.t0.message);

              case 10:
                validateStatus(response.status);

                if (response.ok) {
                  _context4.next = 13;
                  break;
                }

                throw new HttpError(response.text());

              case 13:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this, [[1, 7]]);
      }));

      return function sendCommand(_x4) {
        return _sendCommand.apply(this, arguments);
      };
    }(),
    getSubscribeAdapterOptions: function () {
      var _getSubscribeAdapterOptions = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee5() {
        var response, result;
        return _regenerator.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.prev = 0;
                _context5.next = 3;
                return fetch((0, _get_root_based_url.default)(origin, rootPath, '/api/subscribe'), {
                  method: 'POST',
                  headers: {
                    'Content-Type': 'application/json'
                  },
                  credentials: 'same-origin',
                  body: (0, _stringify.default)({
                    origin: origin,
                    rootPath: rootPath
                  })
                });

              case 3:
                response = _context5.sent;
                _context5.next = 9;
                break;

              case 6:
                _context5.prev = 6;
                _context5.t0 = _context5["catch"](0);
                throw new FetchError(_context5.t0.message);

              case 9:
                validateStatus(response.status);

                if (response.ok) {
                  _context5.next = 12;
                  break;
                }

                throw new HttpError(response.text());

              case 12:
                _context5.prev = 12;
                _context5.next = 15;
                return response.json();

              case 15:
                result = _context5.sent;
                _context5.next = 21;
                break;

              case 18:
                _context5.prev = 18;
                _context5.t1 = _context5["catch"](12);
                throw new HttpError(_context5.t1.message);

              case 21:
                return _context5.abrupt("return", result);

              case 22:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this, [[0, 6], [12, 18]]);
      }));

      return function getSubscribeAdapterOptions() {
        return _getSubscribeAdapterOptions.apply(this, arguments);
      };
    }()
  };
};

var _default = createApi;
exports.default = _default;
//# sourceMappingURL=create_api.js.map