"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _resolve_context = require("./resolve_context");

var validate = _interopRequireWildcard(require("./validate"));

var defaultContext = {
  origin: '',
  rootPath: '',
  staticPath: 'static'
};

var createContextBasedConnector = function createContextBasedConnector(getContextBasedUrl) {
  return function (propsList) {
    return function (Component) {
      validate.arrayOfString(propsList, 'Props list');
      var propsListSize = propsList.length;
      return (
        /*#__PURE__*/
        function (_React$PureComponent) {
          (0, _inherits2.default)(ContextBasedComponent, _React$PureComponent);

          function ContextBasedComponent() {
            var _getPrototypeOf2;

            var _this;

            (0, _classCallCheck2.default)(this, ContextBasedComponent);

            for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }

            _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(ContextBasedComponent)).call.apply(_getPrototypeOf2, [this].concat(args)));
            (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "functionAsChildComponent", function (context) {
              var props = _this.props;
              var staticBasedProps = {};

              for (var propertyIndex = 0; propertyIndex < propsListSize; propertyIndex++) {
                var propertyName = propsList[propertyIndex];
                var propertyValue = props[propertyName];

                if (Array.isArray(propertyValue)) {
                  var subProps = [];
                  var subPropertySize = propertyValue.length;

                  for (var subPropertyIndex = 0; subPropertyIndex < subPropertySize; subPropertyIndex++) {
                    subProps[subPropertyIndex] = getContextBasedUrl(context || defaultContext, propertyValue[subPropertyIndex]);
                  }

                  staticBasedProps[propertyName] = subProps;
                } else {
                  staticBasedProps[propertyName] = getContextBasedUrl(context || defaultContext, propertyValue);
                }
              }

              return _react.default.createElement(Component, (0, _extends2.default)({}, props, staticBasedProps));
            });
            return _this;
          }

          (0, _createClass2.default)(ContextBasedComponent, [{
            key: "render",
            value: function render() {
              return _react.default.createElement(_resolve_context.Consumer, null, this.functionAsChildComponent);
            }
          }]);
          return ContextBasedComponent;
        }(_react.default.PureComponent)
      );
    };
  };
};

var _default = createContextBasedConnector;
exports.default = _default;
//# sourceMappingURL=create_context_based_connector.js.map