"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _effects = require("redux-saga/effects");

var _constants = require("./constants");

var _action_types = require("./action_types");

var _actions = require("./actions");

var _get_hash = _interopRequireDefault(require("./get_hash"));

var _unsubscribe_read_model_topics_saga = _interopRequireDefault(require("./unsubscribe_read_model_topics_saga"));

var diffListenerSaga =
/*#__PURE__*/
_regenerator.default.mark(function diffListenerSaga(_ref, connectAction) {
  var sagaKey, sagaManager, queryId, store, diffQueue, _loop, _ret;

  return _regenerator.default.wrap(function diffListenerSaga$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          sagaKey = _ref.sagaKey, sagaManager = _ref.sagaManager, queryId = _ref.queryId, store = _ref.store;
          diffQueue = [];
          _loop =
          /*#__PURE__*/
          _regenerator.default.mark(function _loop() {
            var _ref2, message, _ref3, readModelsDiffVersionsMap, readModelName, resolverName, resolverArgs, key, lastDiffVersionByKey, nextDiffs;

            return _regenerator.default.wrap(function _loop$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return (0, _effects.take)(function (action) {
                      return action.type === _action_types.DISPATCH_TOPIC_MESSAGE && action.message.type === _constants.diffMessageType && action.message.queryId === queryId;
                    });

                  case 2:
                    _ref2 = _context.sent;
                    message = _ref2.message;
                    diffQueue.push(message);
                    _context.next = 7;
                    return (0, _effects.select)();

                  case 7:
                    _ref3 = _context.sent;
                    readModelsDiffVersionsMap = _ref3.readModels[_constants.diffVersionsMap];
                    readModelName = connectAction.readModelName;
                    resolverName = (0, _get_hash.default)(connectAction.resolverName);
                    resolverArgs = (0, _get_hash.default)(connectAction.resolverArgs);
                    key = "".concat(readModelName).concat(resolverName).concat(resolverArgs);

                    if (readModelsDiffVersionsMap.hasOwnProperty(key)) {
                      _context.next = 15;
                      break;
                    }

                    return _context.abrupt("return", "continue");

                  case 15:
                    lastDiffVersionByKey = readModelsDiffVersionsMap[key];
                    diffQueue = diffQueue.filter(function (savedDiff) {
                      return !(savedDiff.diffVersion <= lastDiffVersionByKey);
                    });
                    nextDiffs = diffQueue.sort(function (a, b) {
                      return a.diffVersion - b.diffVersion;
                    });

                  case 18:
                    if (!(nextDiffs.length > 0 && nextDiffs[0].diffVersion === lastDiffVersionByKey + 1)) {
                      _context.next = 25;
                      break;
                    }

                    _context.next = 21;
                    return (0, _effects.put)((0, _actions.applyReadModelDiff)(connectAction.readModelName, connectAction.resolverName, connectAction.resolverArgs, nextDiffs[0].diff));

                  case 21:
                    nextDiffs.splice(0, 1);
                    lastDiffVersionByKey++;
                    _context.next = 18;
                    break;

                  case 25:
                    readModelsDiffVersionsMap[key] = lastDiffVersionByKey;

                    if (!(nextDiffs.length > 10)) {
                      _context.next = 29;
                      break;
                    }

                    return _context.delegateYield((0, _unsubscribe_read_model_topics_saga.default)({
                      queryId: queryId
                    }), "t0", 28);

                  case 28:
                    return _context.delegateYield(sagaManager.stop("".concat(_action_types.CONNECT_READMODEL).concat(sagaKey), function () {
                      return store.dispatch((0, _objectSpread2.default)({}, connectAction, {
                        skipConnectionManager: true
                      }));
                    }), "t1", 29);

                  case 29:
                  case "end":
                    return _context.stop();
                }
              }
            }, _loop, this);
          });

        case 3:
          if (!true) {
            _context2.next = 10;
            break;
          }

          return _context2.delegateYield(_loop(), "t0", 5);

        case 5:
          _ret = _context2.t0;

          if (!(_ret === "continue")) {
            _context2.next = 8;
            break;
          }

          return _context2.abrupt("continue", 3);

        case 8:
          _context2.next = 3;
          break;

        case 10:
        case "end":
          return _context2.stop();
      }
    }
  }, diffListenerSaga, this);
});

var _default = diffListenerSaga;
exports.default = _default;
//# sourceMappingURL=diff_listener_saga.js.map