"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _effects = require("redux-saga/effects");

var _get_hash = _interopRequireDefault(require("./get_hash"));

var _constants = require("./constants");

var _action_types = require("./action_types");

var _unsubscribe_view_model_topics_saga = _interopRequireDefault(require("./unsubscribe_view_model_topics_saga"));

var eventListenerSaga =
/*#__PURE__*/
_regenerator.default.mark(function eventListenerSaga(_ref, connectAction) {
  var viewModels, sagaKey, sagaManager, eventTypes, store, eventQueue, _loop, _ret;

  return _regenerator.default.wrap(function eventListenerSaga$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          viewModels = _ref.viewModels, sagaKey = _ref.sagaKey, sagaManager = _ref.sagaManager, eventTypes = _ref.eventTypes, store = _ref.store;
          eventQueue = [];
          _loop =
          /*#__PURE__*/
          _regenerator.default.mark(function _loop() {
            var _ref2, event, _ref3, viewModelsAggregateVersionsMap, key, aggregateVersionByAggregateId, lastAppliedAggregateVersion, nextEventsForAggregate;

            return _regenerator.default.wrap(function _loop$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return (0, _effects.take)(function (action) {
                      return action.type === _action_types.DISPATCH_TOPIC_MESSAGE && eventTypes.indexOf(action.message.type) > -1 && (connectAction.aggregateIds === '*' || connectAction.aggregateIds.indexOf(action.message.aggregateId) > -1);
                    });

                  case 2:
                    _ref2 = _context.sent;
                    event = _ref2.message;
                    eventQueue.push(event);
                    _context.next = 7;
                    return (0, _effects.select)();

                  case 7:
                    _ref3 = _context.sent;
                    viewModelsAggregateVersionsMap = _ref3.viewModels[_constants.aggregateVersionsMap];
                    key = "".concat(connectAction.viewModelName).concat((0, _get_hash.default)(connectAction.aggregateIds)).concat((0, _get_hash.default)(connectAction.aggregateArgs));
                    aggregateVersionByAggregateId = viewModelsAggregateVersionsMap[key];

                    if (aggregateVersionByAggregateId) {
                      _context.next = 13;
                      break;
                    }

                    return _context.abrupt("return", "continue");

                  case 13:
                    if (connectAction.aggregateIds === '*' && !aggregateVersionByAggregateId.hasOwnProperty(event.aggregateId)) {
                      aggregateVersionByAggregateId[event.aggregateId] = event.aggregateVersion - 1;
                    }

                    lastAppliedAggregateVersion = aggregateVersionByAggregateId[event.aggregateId];
                    eventQueue = eventQueue.filter(function (savedEvent) {
                      return !(savedEvent.aggregateVersion <= lastAppliedAggregateVersion && savedEvent.aggregateId === event.aggregateId);
                    });
                    nextEventsForAggregate = eventQueue.filter(function (savedEvent) {
                      return savedEvent.aggregateId === event.aggregateId;
                    }).sort(function (a, b) {
                      return a.aggregateVersion - b.aggregateVersion;
                    });

                  case 17:
                    if (!(nextEventsForAggregate.length > 0)) {
                      _context.next = 24;
                      break;
                    }

                    _context.next = 20;
                    return (0, _effects.put)(nextEventsForAggregate[0]);

                  case 20:
                    lastAppliedAggregateVersion = nextEventsForAggregate[0].aggregateVersion;
                    nextEventsForAggregate.splice(0, 1);
                    _context.next = 17;
                    break;

                  case 24:
                    aggregateVersionByAggregateId[event.aggregateId] = lastAppliedAggregateVersion;

                    if (!(nextEventsForAggregate.length > 10)) {
                      _context.next = 28;
                      break;
                    }

                    return _context.delegateYield((0, _unsubscribe_view_model_topics_saga.default)({
                      viewModels: viewModels,
                      viewModelName: connectAction.viewModelName,
                      aggregateIds: connectAction.aggregateIds
                    }), "t0", 27);

                  case 27:
                    return _context.delegateYield(sagaManager.stop("".concat(_action_types.CONNECT_VIEWMODEL).concat(sagaKey), function () {
                      return store.dispatch((0, _objectSpread2.default)({}, connectAction, {
                        skipConnectionManager: true
                      }));
                    }), "t1", 28);

                  case 28:
                  case "end":
                    return _context.stop();
                }
              }
            }, _loop, this);
          });

        case 3:
          if (!true) {
            _context2.next = 10;
            break;
          }

          return _context2.delegateYield(_loop(), "t0", 5);

        case 5:
          _ret = _context2.t0;

          if (!(_ret === "continue")) {
            _context2.next = 8;
            break;
          }

          return _context2.abrupt("continue", 3);

        case 8:
          _context2.next = 3;
          break;

        case 10:
        case "end":
          return _context2.stop();
      }
    }
  }, eventListenerSaga, this);
});

var _default = eventListenerSaga;
exports.default = _default;
//# sourceMappingURL=event_listener_saga.js.map